/* --------------------------------------------------------------
          ( 1.2a).

    http://www.imach.uran.ru/cbignum

    Copyright 1999-2007, ..,   PAH.
    All Rights Reserved.

         "public domain",
    ..   ,  
         
          .

           .
        "AS IS"  - 
         .
-------------------------------------------------------------- */
#ifndef _CBIGNUM_H
#define _CBIGNUM_H

#ifndef __cplusplus
#error  Must use C++ for the type cBigNumber.
#endif//__cplusplus

#ifndef CTTY_H
#include "Ctty.h"
#endif//CTTY_H

#ifndef EXARRAY_H
#include "Exarray.h"
#include "Exdebug.h"
#endif//EXARRAY_H

#if 0
#define _CBIGNUM_MT
#endif

//================================================
//        cBigNumber.
//================================================
//             long.
//             long-,
//           
//        ,   
//              
//      .      .
//             length().
//
//           
//        long-,     :
//      -     1,     
//             ;
//      -     .
//           .
//
//           
//        , ..  
//       long-,   0,    
//        .  
//       ,   ,  
//          .
//
//            exblock<long>
//              ,
//            long-,   
//       .      , 
//         -     
//      ,      .
//
//           :
//      checkexpand(n) -      
//                           .
//      checkindex(n)  -      
//                         .
//              .
//
//         checkexpand()  checkindex()   
//          ,    
//        .    
//           .
//
//         NCHECKPTR,   checkexpand() 
//           ,  
//         ,   checkindex()   .
//
//        NCHECKPTR  ,   checkexpand() 
//      checkindex()      .
//
//       :
//
//      exblock<long>           //   .
//      |
//      +- cBigNumber           //  .
//         |
//         +- cBigTemp          //    .
//            |
//            +- cBigInc        //  .
//            +- cBigDec        //  .
//            +- cBigPos        //  .
//            +- cBigNeg        // .
//            +- cBigAbs        //  .
//            +- cBigUnsign     //  .
//            +- cBigCompl      //  .
//            +- cBigXor        //     2.
//            +- cBigAnd        //  .
//            +- cBigOr         //  .
//            +- cBigAdd        // .
//            +- cBigSub        // .
//            +- cBigMul        // .
//            +- cBigDiv        // .
//            +- cBigDivMod     //   .
//            +- cBigMod        // .
//            +- cBigShl        //  .
//            +- cBigShr        //  .
//            +- cBigPow        // .
//            +- cBigPowMod     //   .
//            +- cBigSqrt       //  .
//            +- cBigSqrtRm     //    .
//            +- cBigRandom     //  .

//================================================
//        cBigNumber.
//================================================

class cBigNumber: public exblock<long>
{
protected:                      //     
                                //     
  void  create (long b = 0)     // .   
  {                             //    checkexpand (1).
    e = (long *) exmalloc (EXCALCBLOCKSIZE_1);
    e [0] = 1; e [1] = b;
    len = max_size (EXCALCBLOCKSIZE_1);
    checkindex (1);
  }
                                //   cBigTemp.
  cBigNumber (exblockstack<long> &stack) { stack.get (*this); }

public:

//      .                                   //  :
  cBigNumber ()                 { create (0);   }       // .
  cBigNumber (long b)           { create (b);   }       // .
  cBigNumber (const cBigNumber&);                       // .
  cBigNumber (const char* psz, unsigned radix);         // .

//      .
  ~cBigNumber()                 { exfree (e);   }

//        .
  size_t      length  () const  { return (size_t)(*e);} //  .
  const long* code    () const  { return e + 1;       } //  .
  const long& loword  () const  { return e [1];       } //  .
  const long& hiword  () const  { return e [length()];} //  .
  size_t      isfit   () const;                         // ?
  size_t      words   () const;                         //   .
  size_t      exwords () const;                         //   0-.

//        .
  long        bits    () const;                         //   .
  cBigNumber& setbits   (const cBigNumber&);
  cBigNumber& setbits   (long);
  long        exbits  () const;                         //   0-.
  cBigNumber& setexbits (const cBigNumber&);
  cBigNumber& setexbits (long);

//       .
//          ,   
//         .
  cBigNumber& fit   ();                                 // .
  cBigNumber& tab   ();                                 //  .
  cBigNumber& gc    ();                                 //  .
  cBigNumber& pack  ();                                 //  .
const cBigNumber& fit   () const { return ((cBigNumber*)this)->fit();   }
const cBigNumber& tab   () const { return ((cBigNumber*)this)->tab();   }
const cBigNumber& gc    () const { return ((cBigNumber*)this)->gc();    }
const cBigNumber& pack  () const { return ((cBigNumber*)this)->pack();  }

//       .   -1 = , 0 = , 1 = .
  int         comp  (const cBigNumber&) const;          //  
  int         comp  (long)              const;          //  .
  int         comp0 ()                  const;          //   0.

//        c  .
  cBigNumber& neg   ()  { return setneg  (*this); }     //  .
  cBigNumber& abs   ();                                 //  .
  cBigNumber& unsign();                                 //  .
//cBigNumber& compl ()  { return setcompl(*this); }     //  .
  cBigNumber& operator ++();                            //  .
  cBigNumber& operator --();                            //  .
  cBigNumber& mul2  ();                                 //   2.
  cBigNumber& div2  ();                                 //   2.
  cBigNumber& pow2  ();                                 // .
  cBigNumber& sqrt  ();                                 //  .

//           .
//         .
  cBigNumber& set         (const cBigNumber&);          // .
  cBigNumber& set         (long);
  cBigNumber& setneg      (const cBigNumber&);          //  .
  cBigNumber& setneg      (long);
  cBigNumber& setabs      (const cBigNumber&);          //  .
  cBigNumber& setabs      (long);
  cBigNumber& setunsign   (const cBigNumber&);          //  .
  cBigNumber& setunsign   (long);
  cBigNumber& setcompl    (const cBigNumber&);          //  .
  cBigNumber& setcompl    (long);
  cBigNumber& setxor (const cBigNumber&, const cBigNumber&);    // 
  cBigNumber& setxor (const cBigNumber&, long);                 //  
  cBigNumber& setxor (long, const cBigNumber&);                 //  2.
  cBigNumber& setxor (long, long);
  cBigNumber& setand (const cBigNumber&, const cBigNumber&);    // 
  cBigNumber& setand (const cBigNumber&, long);                 // .
  cBigNumber& setand (long, const cBigNumber&);
  cBigNumber& setand (long, long);
  cBigNumber& setor  (const cBigNumber&, const cBigNumber&);    // 
  cBigNumber& setor  (const cBigNumber&, long);                 // .
  cBigNumber& setor  (long, const cBigNumber&);
  cBigNumber& setor  (long, long);
  cBigNumber& setadd (const cBigNumber&, const cBigNumber&);    // .
  cBigNumber& setadd (const cBigNumber&, long);
  cBigNumber& setadd (long, const cBigNumber&);
  cBigNumber& setadd (long, long);
  cBigNumber& setsub (const cBigNumber&, const cBigNumber&);    // .
  cBigNumber& setsub (const cBigNumber&, long);
  cBigNumber& setsub (long, const cBigNumber&);
  cBigNumber& setsub (long, long);
  cBigNumber& setmul (const cBigNumber&, const cBigNumber&);    // .
  cBigNumber& setmul (const cBigNumber&, long);
  cBigNumber& setmul (long, const cBigNumber&);
  cBigNumber& setmul (long, long);
  cBigNumber& setdiv (const cBigNumber&, const cBigNumber&);    // .
  cBigNumber& setdiv (const cBigNumber&, long);
  cBigNumber& setdiv (long, const cBigNumber&);
  cBigNumber& setdiv (long, long);
  cBigNumber& setmod (const cBigNumber&, const cBigNumber&);    // .
  cBigNumber& setmod (const cBigNumber&, long);
  cBigNumber& setmod (long, const cBigNumber&);
  cBigNumber& setmod (long, long);
  cBigNumber& setshl (const cBigNumber&, const cBigNumber&);    // 
  cBigNumber& setshl (const cBigNumber&, long);                 // .
  cBigNumber& setshl (long, const cBigNumber&);
  cBigNumber& setshl (long, long);
  cBigNumber& setshr (const cBigNumber&, const cBigNumber&);    // 
  cBigNumber& setshr (const cBigNumber&, long);                 // .
  cBigNumber& setshr (long, const cBigNumber&);
  cBigNumber& setshr (long, long);
  cBigNumber& setpow (const cBigNumber&, const cBigNumber&);    // .
  cBigNumber& setpow (const cBigNumber&, long);
  cBigNumber& setpow (long, const cBigNumber&);
  cBigNumber& setpow (long, long);
  cBigNumber& setpowmod (const cBigNumber&, const cBigNumber&,  // 
                         const cBigNumber&);                    //  .
  cBigNumber& setpowmod (const cBigNumber&, const cBigNumber&, long);
  cBigNumber& setpowmod (const cBigNumber&, long, const cBigNumber&);
  cBigNumber& setpowmod (const cBigNumber&, long, long);
  cBigNumber& setpowmod (long, const cBigNumber&, const cBigNumber&);
  cBigNumber& setpowmod (long, const cBigNumber&, long);
  cBigNumber& setpowmod (long, long, const cBigNumber&);
  cBigNumber& setpowmod (long, long, long);
  cBigNumber& setsqrt   (const cBigNumber&);                    // . .
  cBigNumber& setsqrt   (long);
  cBigNumber& setrandom (unsigned long (*p)(), unsigned long);  // .

//      .
  cBigNumber& operator =  (const cBigNumber& b) { return set (b);       }
  cBigNumber& operator =  (long b)              { return set (b);       }

//        c  .
//          .
  cBigNumber& operator ^= (const cBigNumber&);  //    mod 2.
  cBigNumber& operator ^= (long);
  cBigNumber& operator &= (const cBigNumber&);  //  .
  cBigNumber& operator &= (long);
  cBigNumber& operator |= (const cBigNumber&);  //  .
  cBigNumber& operator |= (long);
  cBigNumber& operator += (const cBigNumber&);  // .
  cBigNumber& operator += (long);
  cBigNumber& operator -= (const cBigNumber&);  // .
  cBigNumber& operator -= (long);
  cBigNumber& operator *= (const cBigNumber&);  // .
  cBigNumber& operator *= (long);
  cBigNumber& operator /= (const cBigNumber&);  // .
  cBigNumber& operator /= (long);
  cBigNumber& operator %= (const cBigNumber&);  // .
  cBigNumber& operator %= (long);
  cBigNumber& operator<<= (const cBigNumber&);  //  .
  cBigNumber& operator<<= (long);
  cBigNumber& operator>>= (const cBigNumber&);  //  .
  cBigNumber& operator>>= (long);
  cBigNumber& pow         (const cBigNumber&);  // .
  cBigNumber& pow         (long);

//        c  .
//            .
  cBigNumber& powmod      (const cBigNumber&, const cBigNumber&);
  cBigNumber& powmod      (const cBigNumber&, long);
  cBigNumber& powmod      (long, const cBigNumber&);
  cBigNumber& powmod      (long, long);

//           long-   .
  cBigNumber& set         (const cBigNumber&, size_t k);
  cBigNumber& set         (long, size_t k);
  cBigNumber& setr        (const cBigNumber&, size_t k);

//           long- .
  cBigNumber& add         (const cBigNumber&, size_t k = 0);
  cBigNumber& add         (long, size_t k = 0);
  cBigNumber& sub         (const cBigNumber&, size_t k = 0);
  cBigNumber& sub         (long, size_t k = 0);

//          .
//          ,
//        .
  cBigNumber& addmul      (const cBigNumber&, const cBigNumber&);
  cBigNumber& addmul      (const cBigNumber&, long);
  cBigNumber& addmul      (long, const cBigNumber&);
  cBigNumber& addmul      (long, long);
  cBigNumber& submul      (const cBigNumber&, const cBigNumber&);
  cBigNumber& submul      (const cBigNumber&, long);
  cBigNumber& submul      (long, const cBigNumber&);
  cBigNumber& submul      (long, long);

//          .
//          , 
//          .
  cBigNumber& setdivmod   (cBigNumber&, const cBigNumber&);
  cBigNumber& setdivmod   (cBigNumber&, long);

//           .
//          , 
//          .
  cBigNumber& setsqrtrm   (cBigNumber&);

//           .
//          .
//         .
//            .
  cBigNumber& addmultab   (const cBigNumber&, const cBigNumber&, size_t k = 0);
  cBigNumber& addmultab   (const cBigNumber&, long, size_t k = 0);
  cBigNumber& submultab   (const cBigNumber&, const cBigNumber&, size_t k = 0);
  cBigNumber& submultab   (const cBigNumber&, long, size_t k = 0);

//         .
//          .
//       o  ,
//          
//            .
  cBigNumber& setdivtab (const cBigNumber&, const cBigNumber&); // .
  cBigNumber& setdivtab (long, const cBigNumber&);
  cBigNumber& setmodtab (const cBigNumber&, const cBigNumber&); // .
  cBigNumber& setmodtab (long, const cBigNumber&);

//           .
//             
//             .
//         .
//          .
  cBigNumber& setdivmodtab    (cBigNumber&, const cBigNumber&); //  
                                                                // .
//      .
static  const char* pszConverting;
static  const char* pszFormatting;

//       .
#define MAX_RADIX 16
static  const char  numtochar [2] [MAX_RADIX + 1];      // 
static        char  chartonum [UCHAR_MAX + 1];          //  .
static  const long          maxradix[][4];
static  exarray<cBigNumber> powradix [MAX_RADIX + 1];
static  size_t  SqrTab  (unsigned radix, size_t len = 0, size_t max_np = 0);
  cBigNumber& setunsign (const EXPTR(char) ps,          //  
                         unsigned radix,                //   .
                         unsigned width);
  cBigNumber& set       (const char* psz,               // 
                         unsigned radix = 10);          //   .
#define cBigNumber_uppercase    0x00040000L
#define cBigNumber_showbase     0x00080000L
#define cBigNumber_showpos      0x00200000L
#define cBigNumber_unsign       0x80000000L
  char*       toatmp    (unsigned radix = 10,           //  
                         unsigned width = 0,            //  .
                         long     fill  = 0)    const;
  void        dump      () const;                       //   .
  void        info      () const;                       //   .

//           .
  void        erange    ()  const;                      //  .
  long        tolong    ()  const;
  int         toint     ()  const;
  short       toshort   ()  const;

//             C.
  operator const void * ()  const       { return (comp0()? e: 0);       }
  int        operator ! ()  const       { return (comp0() == 0);        }

//       .
static  void  maskdiv0  (int);          //    0.
static  int   testdiv0  ();             //     0?

//           ( ).
#ifndef _CBIGNUM_MT
static  cBigNumber& lastdivmod ();      //   .
static  cBigNumber& lastrootrm ();      //   .
#endif//_CBIGNUM_MT
};

//================================================
//         .
//================================================

//       Strong Probable Primality   b.
int     b_SPRP      (const cBigNumber& n, const cBigNumber& b);

//================================================
//          (prime.cpp).
//================================================

//       Strong Probable Primality.
int     SPRP        (const cBigNumber&);
int     SPRP        (const cBigNumber&, cBigNumber&);
int FastSPRP        (const cBigNumber&);
int FastSPRP        (const cBigNumber&, cBigNumber&);
int LastSPRP        (const cBigNumber&);
int LastSPRP        (const cBigNumber&, cBigNumber&);

//       .
int TestFactor      (const cBigNumber&);
int TestFactor      (const cBigNumber&, cBigNumber&);
int TestSmallFactor (const cBigNumber&);
int TestSmallFactor (const cBigNumber&, cBigNumber&);
int TestLargeFactor (const cBigNumber&);
int TestLargeFactor (const cBigNumber&, cBigNumber&);

//        ( + SPRP).
int IsPrime         (const cBigNumber&);
int IsProvedPrime   (const cBigNumber&);
int IsMillerPrime   (const cBigNumber&);
int IsStrongPrime   (const cBigNumber&);

//       ,    1.1a
#ifdef  _CBIGNUM_HASFACTOR
inline int HasFactor(const cBigNumber& n) { return TestFactor(n);   }
#endif//_CBIGNUM_HASFACTOR

//================================================
//        .
//================================================

cTTY& operator << (cTTY& os, const cBigNumber& b);
void operator <<= (cTTY& os, const cBigNumber& b);

extern cTTY cBigNumberMessages;         //  .
extern cTTY cBigNumberProgress;         //  -.

//================================================
//         .
//================================================

class cHexDump
{
  char buffer [CHAR_BIT * sizeof (long) * 3 / 8];
public:
  cHexDump (unsigned long n);
  cHexDump& operator = (cHexDump&);
  operator const char*() { return (buffer); }
};

//================================================
//         
//        long   .
//================================================

class _cBigLong
{
  long e [2];           //  .

public:                 //   .

  _cBigLong         (long n = 0) { e [0] = 1; e [1] = n;        }

  _cBigLong& operator = (long n) { e [1] = n; return *this;     }

#ifdef  NCHECKPTR

//         
//           .

  long*       base()            { return (e);                   }

#else

//         
//           :
//            
//      ,  ::exalloc_status.range_handler.

  _cBigLong&  block()           { return (*this);               }
  exptr<long> begin()           { return exptr<long> (e, 2);    }
  operator    exptr<long>()     { return exptr<long> (e, 2);    }

#endif
};

#ifdef  __cplusplus
extern "C" {
#endif//__cplusplus

//================================================
//       .
//================================================

extern  size_t      cBigNumberMaskDiv0;     //    0.
#ifndef _CBIGNUM_MT
extern  cBigNumber  cBigNumberLastDivMod;   //   .
extern  cBigNumber  cBigNumberLastRootRm;   //   .
#endif//_CBIGNUM_MT

//================================================
//       .
//================================================

void    cBigNumberDump    (const EXPTR(long) p1);
void    cBigNumberInfo    (const EXPTR(long) p1);
void    cBigNumberERange  (const EXPTR(long) p1);
size_t  cBigNumberWords   (const EXPTR(long) p1);
int     cLongBits         (long);
int     cULongBits        (unsigned long);
long    cBigNumberBits    (const EXPTR(long) p1);
size_t  cBigNumberExWords (const EXPTR(long) p1);
int     cLongExBits       (long);
int     cLongExactLog2    (long);
long    cBigNumberExBits  (const EXPTR(long) p1);
size_t  cBigNumberIsFit   (const EXPTR(long) p1);
size_t _cBigNumberFit           (EXPTR(long) p1);
size_t _cBigNumberFitTo         (EXPTR(long) p1, size_t n);
int     cBigNumberComp    (const EXPTR(long) p1, const EXPTR(long) p2);
int     cBigNumberCompHigh(const EXPTR(long) p1, const EXPTR(long) p2);
void    cBigNumberCopy    (const EXPTR(long) p1, EXPTR(long) p);
void    cBigNumberCompl   (const EXPTR(long) p1, EXPTR(long) p);
void    cBigNumberCopyShl (const EXPTR(long) p1, size_t k1, EXPTR(long) p);
void    cBigNumberCopyShr (const EXPTR(long) p1, size_t k1, EXPTR(long) p);
void    cBigNumberCutOut  (const EXPTR(long) p1, size_t k1, size_t n,
                                 EXPTR(long) p);
size_t _cBigNumberNeg     (const EXPTR(long) p1, EXPTR(long) p);
size_t _cBigNumberMInc          (EXPTR(long) p1);
size_t _cBigNumberMDec          (EXPTR(long) p1);
size_t _cBigNumberMMul2         (EXPTR(long) p1);
size_t _cBigNumberMDiv2         (EXPTR(long) p1);
size_t _cBigNumberMul2    (const EXPTR(long) p1, EXPTR(long) p);
size_t _cBigNumberDiv2    (const EXPTR(long) p1, EXPTR(long) p);
void    cBigNumberTab           (EXPTR(long) p1);
size_t _cBigNumberXor     (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
size_t _cBigNumberAnd     (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
size_t _cBigNumberOr      (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
size_t _cBigNumberAdd     (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
size_t _cBigNumberSub     (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
size_t _cBigNumberSubS    (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
size_t _cBigNumberMAdd          (EXPTR(long) p1, const EXPTR(long) p2);
size_t _cBigNumberMSub          (EXPTR(long) p1, const EXPTR(long) p2);
size_t  cBigNumberSkipLow0(const EXPTR(long) p1);
void    cBigNumberMAddMulM      (EXPTR(long) p1, const EXPTR(long) p2,
                                 unsigned long l2, size_t k2);
void    cBigNumberMSubMulM      (EXPTR(long) p1, const EXPTR(long) p2,
                                 unsigned long l2, size_t k2);
void    cBigNumberMAddM         (EXPTR(long) p1, const EXPTR(long) p2,
                                 size_t k2);
void    cBigNumberMSubM         (EXPTR(long) p1, const EXPTR(long) p2,
                                 size_t k2);
size_t _cBigNumberMSubD         (EXPTR(long) p1, const EXPTR(long) p2,
                                 size_t k2);
size_t _cBigNumberMMul2M        (EXPTR(long) p1);
size_t _cBigNumberMDiv2D        (EXPTR(long) p1);
void    cBigNumberMShrM         (EXPTR(long) p1);
void    cBigNumberMShlD         (EXPTR(long) p1);
void    cBigNumberMAddShl       (EXPTR(long) p1, const EXPTR(long) p2,
                                 size_t k2);
void    cBigNumberMSubShl       (EXPTR(long) p1, const EXPTR(long) p2,
                                 size_t k2);
void    cBigNumberMAddMulShl    (EXPTR(long) p1, const EXPTR(long) p2,
                                 size_t k, EXPTR(long) p);
void    cBigNumberMSubMulShl    (EXPTR(long) p1, const EXPTR(long) p2,
                                 size_t k, EXPTR(long) p);
void    cBigNumberMAddMulShlTab
                          (const EXPTR(long) p1, const EXPTR(long) p2,
                                 size_t k, EXPTR(long) p);
void    cBigNumberMSubMulShlTab
                          (const EXPTR(long) p1, const EXPTR(long) p2,
                                 size_t k, EXPTR(long) p);
void    cBigNumberMAddMulShlKar (EXPTR(long) p1, EXPTR(long) p2,
                                 size_t k, EXPTR(long) p);
void    cBigNumberMSubMulShlKar (EXPTR(long) p1, EXPTR(long) p2,
                                 size_t k, EXPTR(long) p);
void    cBigNumberMAddMul (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
void    cBigNumberMSubMul (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
void    cBigNumberMul     (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
void    cLongMul                (long, long, long p [2]);
void    cULongMul      (unsigned long, unsigned long, unsigned long p [2]);
void    cBigNumberDiv0();
void    cBigNumberMModDivTab    (EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
void    cBigNumberMModDiv       (EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
void    cBigNumberMModTab       (EXPTR(long) p1, const EXPTR(long) p2);
void    cBigNumberMMod          (EXPTR(long) p1, const EXPTR(long) p2);
void    cBigNumberPow           (EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
void    cBigNumberPowMod        (EXPTR(long) p1, const EXPTR(long) p2,
                                                 const EXPTR(long) mod,
                                 EXPTR(long) p);
void    cBigNumberMRmSqrt       (EXPTR(long) p1, EXPTR(long) p);
void    cBigNumberRandom  (unsigned long (*pfnRand)(), unsigned long lBits,
                                 EXPTR(long) p);
#ifdef  __cplusplus
}
#endif//__cplusplus

//================================================
//       inline-.
//================================================

inline  size_t  cBigNumberNeg     (const EXPTR(long) p1, EXPTR(long) p)
{
  return (size_t)(*(p)=(long)_cBigNumberNeg (p1, p));
}

inline  size_t  cBigNumberMInc          (EXPTR(long) p1)
{
  return (size_t)(*(p1)=(long)_cBigNumberMInc (p1));
}

inline  size_t  cBigNumberMDec          (EXPTR(long) p1)
{
  return (size_t)(*(p1)=(long)_cBigNumberMDec (p1));
}

inline  size_t  cBigNumberMMul2         (EXPTR(long) p1)
{
  return (size_t)(*(p1)=(long)_cBigNumberMMul2 (p1));
}

inline  size_t  cBigNumberMDiv2         (EXPTR(long) p1)
{
  return (size_t)(*(p1)=(long)_cBigNumberMDiv2 (p1));
}

inline  size_t  cBigNumberMul2   (const EXPTR(long) p1, EXPTR(long) p)
{
  return (size_t)(*(p)=(long)_cBigNumberMul2 (p1, p));
}

inline  size_t  cBigNumberDiv2   (const EXPTR(long) p1, EXPTR(long) p)
{
  return (size_t)(*(p)=(long)_cBigNumberDiv2 (p1, p));
}

inline  size_t  cBigNumberFit          (EXPTR(long) p1)
{
  return (size_t)(*(p1)=(long)_cBigNumberFit (p1));
}

inline  size_t  cBigNumberFitTo        (EXPTR(long) p1, size_t n)
{
  return (size_t)(*(p1)=(long)_cBigNumberFitTo (p1, n));
}

inline  size_t  cBigNumberXor    (const EXPTR(long) p1, const EXPTR(long) p2,
                                        EXPTR(long) p)
{
  return (size_t)(*(p)=(long)_cBigNumberXor (p1, p2, p));
}

inline  size_t  cBigNumberAnd    (const EXPTR(long) p1, const EXPTR(long) p2,
                                        EXPTR(long) p)
{
  return (size_t)(*(p)=(long)_cBigNumberAnd (p1, p2, p));
}

inline  size_t  cBigNumberOr     (const EXPTR(long) p1, const EXPTR(long) p2,
                                        EXPTR(long) p)
{
  return (size_t)(*(p)=(long)_cBigNumberOr  (p1, p2, p));
}

inline  size_t  cBigNumberAdd    (const EXPTR(long) p1, const EXPTR(long) p2,
                                        EXPTR(long) p)
{
  return (size_t)(*(p)=(long)_cBigNumberAdd (p1, p2, p));
}

inline  size_t  cBigNumberSub    (const EXPTR(long) p1, const EXPTR(long) p2,
                                        EXPTR(long) p)
{
  return (size_t)(*(p)=(long)_cBigNumberSub (p1, p2, p));
}

inline  size_t  cBigNumberSubS   (const EXPTR(long) p1, const EXPTR(long) p2,
                                        EXPTR(long) p)
{
  return (size_t)(*(p)=(long)_cBigNumberSubS (p1, p2, p));
}

inline  size_t  cBigNumberMAdd         (EXPTR(long) p1, const EXPTR(long) p2)
{
  return (size_t)(*(p1)=(long)_cBigNumberMAdd (p1, p2));
}

inline  size_t  cBigNumberMSub         (EXPTR(long) p1, const EXPTR(long) p2)
{
  return (size_t)(*(p1)=(long)_cBigNumberMSub (p1, p2));
}

inline  size_t  cBigNumberMSubD        (EXPTR(long) p1, const EXPTR(long) p2,
                                        size_t k2)
{
  return (size_t)(*(p1)=(long)_cBigNumberMSubD (p1, p2, k2));
}

inline  size_t  cBigNumberMMul2M        (EXPTR(long) p1)
{
  return (size_t)(*(p1)=(long)_cBigNumberMMul2M (p1));
}

inline  size_t  cBigNumberMDiv2D        (EXPTR(long) p1)
{
  return (size_t)(*(p1)=(long)_cBigNumberMDiv2D (p1));
}

//================================================
//       .
//================================================

inline cBigNumber::cBigNumber (const cBigNumber& b)
{
  e = NULL; len = 0;                                    //  .
  checkexpand (b.length());                             //  .
  cBigNumberCopy (EXPTRTYPE(b), EXPTRTYPE(*this));      // .
}

inline cBigNumber::cBigNumber (const char* psz, unsigned radix)
{
  create();                                             //  .
  set (psz, radix);                                     //  .
}

//================================================
//        .
//================================================

inline void   cBigNumber::dump()    const
{
  cBigNumberDump (EXPTRTYPE(*this));
}

inline void   cBigNumber::info()    const
{
  cBigNumberInfo (EXPTRTYPE(*this));
}

inline void   cBigNumber::erange()  const
{
  cBigNumberERange (EXPTRTYPE(*this));
}

inline size_t cBigNumber::isfit()   const
{
  return cBigNumberIsFit (EXPTRTYPE(*this));
}

inline size_t cBigNumber::words()   const
{
  return cBigNumberWords (EXPTRTYPE(*this));
}

inline size_t cBigNumber::exwords() const
{
  return cBigNumberExWords (EXPTRTYPE(*this));
}

inline long   cBigNumber::bits()    const
{
  return cBigNumberBits (EXPTRTYPE(*this));
}

inline long   cBigNumber::exbits()  const
{
  return cBigNumberExBits (EXPTRTYPE(*this));
}

//================================================
//        .
//================================================

inline int  cBigNumber::comp (const cBigNumber& b)  const
{
  return cBigNumberComp (EXPTRTYPE(*this), EXPTRTYPE(b));
}

inline int  cBigNumber::comp (long b)               const
{
  return cBigNumberComp (EXPTRTYPE(*this), EXPTRTYPE(_cBigLong(b)));
}

inline int  cBigNumber::comp0 ()                    const
{
  return cBigNumberComp (EXPTRTYPE(*this), EXPTRTYPE(_cBigLong(0)));
}

//================================================
//         .
//================================================

inline cBigNumber& cBigNumber::abs()
{
  if (hiword() < 0L) neg();
  return *this;
}

inline cBigNumber& cBigNumber::unsign()
{
  if (hiword() < 0L)
  {
    size_t len = length() + 1;
    checkexpand (len); e [0] = (long)len; e [len] = 0;
  }
  return *this;
}

//================================================
//        .
//================================================

inline cBigNumber& cBigNumber::set (const cBigNumber& b)
{
  checkexpand (b.length());
  cBigNumberCopy (EXPTRTYPE(b), EXPTRTYPE(*this));
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::set (long b)
{
  checkexpand (1); e [0] = 1; e [1] = b;
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::setneg (const cBigNumber& b)
{
  checkexpand (b.length() + 1);
  cBigNumberNeg (EXPTRTYPE(b), EXPTRTYPE(*this));
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::setneg (long b)
{
  checkexpand (2); e [0] = 1 + (b == LONG_MIN); e [1] = -b; e [2] = 0;
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::setabs (const cBigNumber& b)
{
  return (b.hiword()<0? set (b): setneg (b));
}

inline cBigNumber& cBigNumber::setabs (long b)
{
  if (b < 0) b = -b;
  checkexpand (2); e [0] = 1 + (b == LONG_MIN); e [1] = b; e [2] = 0;
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::setunsign (const cBigNumber& b)
{
  set (b); return unsign();
}

inline cBigNumber& cBigNumber::setunsign (long b)
{
  checkexpand (2); e [0] = 1 + (b < 0); e [1] = b; e [2] = 0;
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::setcompl (const cBigNumber& b)
{
  checkexpand (b.length());
  cBigNumberCompl (EXPTRTYPE(b), EXPTRTYPE(*this));
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::setcompl (long b)
{
  checkexpand (1); e [0] = 1; e [1] = ~b;
  checkindex (length());
  return *this;
}

//================================================
//         .
//================================================

inline cBigNumber& cBigNumber::operator ^= (const cBigNumber& b)
{
  return setxor (*this, b);
}

inline cBigNumber& cBigNumber::operator ^= (long b)
{
  return setxor (*this, b);
}

inline cBigNumber& cBigNumber::operator &= (const cBigNumber& b)
{
  return setand (*this, b);
}

inline cBigNumber& cBigNumber::operator &= (long b)
{
  return setand (*this, b);
}

inline cBigNumber& cBigNumber::operator |= (const cBigNumber& b)
{
  return setor (*this, b);
}

inline cBigNumber& cBigNumber::operator |= (long b)
{
  return setor (*this, b);
}

inline cBigNumber& cBigNumber::operator += (const cBigNumber& b)
{
  return add (b);
}

inline cBigNumber& cBigNumber::operator += (long b)
{
  return add (b);
}

inline cBigNumber& cBigNumber::operator -= (const cBigNumber& b)
{
  return sub (b);
}

inline cBigNumber& cBigNumber::operator -= (long b)
{
  return sub (b);
}

inline cBigNumber& cBigNumber::operator *= (const cBigNumber& b)
{
  return setmul (*this, b);
}

inline cBigNumber& cBigNumber::operator *= (long b)
{
  return setmul (*this, b);
}

inline cBigNumber& cBigNumber::operator /= (const cBigNumber& b)
{
#ifdef  _CBIGNUM_MT
  cBigNumber cBigNumberLastDivMod;
#endif//_CBIGNUM_MT
  swap (cBigNumberLastDivMod);
  return setdivmod (cBigNumberLastDivMod, b);
}

inline cBigNumber& cBigNumber::operator /= (long b)
{
#ifdef  _CBIGNUM_MT
  cBigNumber cBigNumberLastDivMod;
#endif//_CBIGNUM_MT
  swap (cBigNumberLastDivMod);
  return setdivmod (cBigNumberLastDivMod, b);
}

inline cBigNumber& cBigNumber::operator %= (const cBigNumber& b)
{
  fit();
  cBigNumberMMod (EXPTRTYPE(*this), EXPTRTYPE(b));
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::operator %= (long b)
{
  fit();
  cBigNumberMMod (EXPTRTYPE(*this), EXPTRTYPE(_cBigLong(b)));
  checkindex (length());
  return *this;
}

//================================================
//         .
//================================================

inline cBigNumber& cBigNumber::set (const cBigNumber& b, size_t k)
{
  checkexpand (b.length() + k);
  cBigNumberCopyShl (EXPTRTYPE(b), k, EXPTRTYPE(*this));
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::set (long b, size_t k)
{
  checkexpand (k + 1); e [0] = (long) k; e [k + 1] = b;
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::setr (const cBigNumber& b, size_t k)
{
  checkexpand (b.length() > k? b.length() - k: 1);
  cBigNumberCopyShr (EXPTRTYPE(b), k, EXPTRTYPE(*this));
  checkindex (length());
  return *this;
}

//================================================
//        .
//================================================

inline  long    cBigNumber::tolong()  const
{
  if (size() == 0)      return (0);
  if (length() > 1)     erange();
  return (hiword());
}

inline  int     cBigNumber::toint()   const
{
  long n = tolong();
  if ((int) n != n)     erange();
  return ((int)n);
}

inline  short   cBigNumber::toshort() const
{
  long n = tolong();
  if ((short) n != n)   erange();
  return ((short)n);
}

//================================================
//        .
//================================================

inline void cBigNumber::maskdiv0 (int mask) { cBigNumberMaskDiv0 = mask << 1; }
inline int  cBigNumber::testdiv0()          { return cBigNumberMaskDiv0 == 1; }

#ifndef _CBIGNUM_MT
inline cBigNumber& cBigNumber::lastdivmod() { return cBigNumberLastDivMod; }
inline cBigNumber& cBigNumber::lastrootrm() { return cBigNumberLastRootRm; }
#endif//_CBIGNUM_MT

//================================================
//         .
//================================================

inline  int  operator == (const cBigNumber& a, const cBigNumber& b)
{
  return (a.comp(b) == 0);
}

inline  int  operator == (const cBigNumber& a, long b)
{
  return (a.comp(b) == 0);
}

inline  int  operator == (long b, const cBigNumber& a)
{
  return (a.comp(b) == 0);
}

inline  int  operator != (const cBigNumber& a, const cBigNumber& b)
{
  return (a.comp(b) != 0);
}

inline  int  operator != (const cBigNumber& a, long b)
{
  return (a.comp(b) != 0);
}

inline  int  operator != (long b, const cBigNumber& a)
{
  return (a.comp(b) != 0);
}

inline  int  operator >= (const cBigNumber& a, const cBigNumber& b)
{
  return (a.comp(b) >= 0);
}

inline  int  operator >= (const cBigNumber& a, long b)
{
  return (a.comp(b) >= 0);
}

inline  int  operator >= (long b, const cBigNumber& a)
{
  return (a.comp(b) <= 0);
}

inline  int  operator <= (const cBigNumber& a, const cBigNumber& b)
{
  return (a.comp(b) <= 0);
}

inline  int  operator <= (const cBigNumber& a, long b)
{
  return (a.comp(b) <= 0);
}

inline  int  operator <= (long b, const cBigNumber& a)
{
  return (a.comp(b) >= 0);
}

inline  int  operator >  (const cBigNumber& a, const cBigNumber& b)
{
  return (a.comp(b) > 0);
}

inline  int  operator >  (const cBigNumber& a, long b)
{
  return (a.comp(b) > 0);
}

inline  int  operator >  (long b, const cBigNumber& a)
{
  return (a.comp(b) < 0);
}

inline  int  operator <  (const cBigNumber& a, const cBigNumber& b)
{
  return (a.comp(b) < 0);
}

inline  int  operator <  (const cBigNumber& a, long b)
{
  return (a.comp(b) < 0);
}

inline  int  operator <  (long b, const cBigNumber& a)
{
  return (a.comp(b) > 0);
}

//================================================
//      -   ,
//         .
//================================================

class cBigTemp: public cBigNumber               //    .
{
//       cBigTemp   
//         .
//
//           cBigTemp.
//         , 
//         :
//          cBigTemp   
//          ,   
//       cBigTemp     .
//           
//         ,   .

public:

  static exblockstack<long> stack;      //   .

  cBigTemp (): cBigNumber (stack)   {}  // .
  ~cBigTemp()  { stack.put (*this);  }  // .
/*
  cBigTemp ()  {}                       // .
  ~cBigTemp()  {}                       // .
*/
//          cBigNumber.
//         ,    
//          (-x) = 10;

private:

  cBigNumber& operator ++ ();                   //  .
  cBigNumber& operator -- ();                   //  .
  cBigNumber& operator =  (const cBigNumber&);  // .
  cBigNumber& operator =  (long);
  cBigNumber& operator ^= (const cBigNumber&);  //    mod 2.
  cBigNumber& operator ^= (long);
  cBigNumber& operator &= (const cBigNumber&);  //  .
  cBigNumber& operator &= (long);
  cBigNumber& operator |= (const cBigNumber&);  //  .
  cBigNumber& operator |= (long);
  cBigNumber& operator += (const cBigNumber&);  // .
  cBigNumber& operator += (long);
  cBigNumber& operator -= (const cBigNumber&);  // .
  cBigNumber& operator -= (long);
  cBigNumber& operator *= (const cBigNumber&);  // .
  cBigNumber& operator *= (long);
  cBigNumber& operator /= (const cBigNumber&);  // .
  cBigNumber& operator /= (long);
  cBigNumber& operator %= (const cBigNumber&);  // .
  cBigNumber& operator %= (long);
  cBigNumber& operator<<= (const cBigNumber&);  //  .
  cBigNumber& operator<<= (long);
  cBigNumber& operator>>= (const cBigNumber&);  //  .
  cBigNumber& operator>>= (long);
};

struct cBigInc: public cBigTemp                 //  .
{
  cBigInc   (cBigNumber& a)                             { set (a); ++a; }
};

struct cBigDec: public cBigTemp                 //  .
{
  cBigDec   (cBigNumber& a)                             { set (a); --a; }
};

struct cBigPos: public cBigTemp                 //  .
{
  cBigPos   (const cBigNumber& a)                       { set (a);      }
  cBigPos   (long a)                                    { set (a);      }
};

struct cBigNeg: public cBigTemp                 //  .
{
  cBigNeg   (const cBigNumber& a)                       { setneg (a);   }
  cBigNeg   (long a)                                    { setneg (a);   }
};

struct cBigAbs: public cBigTemp                 //  .
{
  cBigAbs   (const cBigNumber& a)                       { setabs (a);   }
  cBigAbs   (long a)                                    { setabs (a);   }
};

struct cBigUnsign: public cBigTemp              //  .
{
  cBigUnsign(const cBigNumber& a)                       { setunsign (a);}
  cBigUnsign(long a)                                    { setunsign (a);}
};

struct cBigCompl: public cBigTemp               //  .
{
  cBigCompl (const cBigNumber& a)                       { setcompl (a); }
  cBigCompl (long a)                                    { setcompl (a); }
};

struct cBigXor: public cBigTemp                 //     2.
{
  cBigXor (const cBigNumber& a, const cBigNumber& b)    { setxor (a, b); }
  cBigXor (const cBigNumber& a, long b)                 { setxor (a, b); }
  cBigXor (long a, const cBigNumber& b)                 { setxor (a, b); }
  cBigXor (long a, long b)                              { setxor (a, b); }
};

struct cBigAnd: public cBigTemp                 //  .
{
  cBigAnd (const cBigNumber& a, const cBigNumber& b)    { setand (a, b); }
  cBigAnd (const cBigNumber& a, long b)                 { setand (a, b); }
  cBigAnd (long a, const cBigNumber& b)                 { setand (a, b); }
  cBigAnd (long a, long b)                              { setand (a, b); }
};

struct cBigOr: public cBigTemp                  //  .
{
  cBigOr  (const cBigNumber& a, const cBigNumber& b)    { setor  (a, b); }
  cBigOr  (const cBigNumber& a, long b)                 { setor  (a, b); }
  cBigOr  (long a, const cBigNumber& b)                 { setor  (a, b); }
  cBigOr  (long a, long b)                              { setor  (a, b); }
};

struct cBigAdd: public cBigTemp                         // .
{
  cBigAdd (const cBigNumber& a, const cBigNumber& b)    { setadd (a, b); }
  cBigAdd (const cBigNumber& a, long b)                 { setadd (a, b); }
  cBigAdd (long a, const cBigNumber& b)                 { setadd (a, b); }
  cBigAdd (long a, long b)                              { setadd (a, b); }
};

struct cBigSub: public cBigTemp                         // .
{
  cBigSub (const cBigNumber& a, const cBigNumber& b)    { setsub (a, b); }
  cBigSub (const cBigNumber& a, long b)                 { setsub (a, b); }
  cBigSub (long a, const cBigNumber& b)                 { setsub (a, b); }
  cBigSub (long a, long b)                              { setsub (a, b); }
};

struct cBigMul: public cBigTemp                         // .
{
  cBigMul (const cBigNumber& a, const cBigNumber& b)    { setmul (a, b); }
  cBigMul (const cBigNumber& a, long b)                 { setmul (a, b); }
  cBigMul (long a, const cBigNumber& b)                 { setmul (a, b); }
  cBigMul (long a, long b)                              { setmul (a, b); }
};

struct cBigDiv: public cBigTemp                         // .
{
  cBigDiv (const cBigNumber& a, const cBigNumber& b)    { setdiv (a, b); }
  cBigDiv (const cBigNumber& a, long b)                 { setdiv (a, b); }
  cBigDiv (long a, const cBigNumber& b)                 { setdiv (a, b); }
  cBigDiv (long a, long b)                              { setdiv (a, b); }
};

struct cBigDivMod: public cBigTemp                      //   .
{
  cBigDivMod (cBigNumber& a, const cBigNumber& b)       { setdivmod (a, b); }
  cBigDivMod (cBigNumber& a, long b)                    { setdivmod (a, b); }
};

struct cBigMod: public cBigTemp                         // .
{
  cBigMod (const cBigNumber& a, const cBigNumber& b)    { setmod (a, b); }
  cBigMod (const cBigNumber& a, long b)                 { setmod (a, b); }
  cBigMod (long a, const cBigNumber& b)                 { setmod (a, b); }
  cBigMod (long a, long b)                              { setmod (a, b); }
};

struct cBigShl: public cBigTemp                         //  .
{
  cBigShl (const cBigNumber& a, const cBigNumber& b)    { setshl (a, b); }
  cBigShl (const cBigNumber& a, long b)                 { setshl (a, b); }
  cBigShl (long a, const cBigNumber& b)                 { setshl (a, b); }
  cBigShl (long a, long b)                              { setshl (a, b); }
};

struct cBigShr: public cBigTemp                         //  .
{
  cBigShr (const cBigNumber& a, const cBigNumber& b)    { setshr (a, b); }
  cBigShr (const cBigNumber& a, long b)                 { setshr (a, b); }
  cBigShr (long a, const cBigNumber& b)                 { setshr (a, b); }
  cBigShr (long a, long b)                              { setshr (a, b); }
};

struct cBigPow: public cBigTemp                         // .
{
  cBigPow (const cBigNumber& a, const cBigNumber& b)    { setpow (a, b); }
  cBigPow (const cBigNumber& a, long b)                 { setpow (a, b); }
  cBigPow (long a, const cBigNumber& b)                 { setpow (a, b); }
  cBigPow (long a, long b)                              { setpow (a, b); }
};

struct cBigPowMod: public cBigTemp                      //   .
{
  cBigPowMod (const cBigNumber& a, const cBigNumber& b, cBigNumber& mod)
                                                { setpowmod (a, b, mod); }
  cBigPowMod (const cBigNumber& a, const cBigNumber& b, long mod)
                                                { setpowmod (a, b, mod); }
  cBigPowMod (const cBigNumber& a, long b, cBigNumber& mod)
                                                { setpowmod (a, b, mod); }
  cBigPowMod (const cBigNumber& a, long b, long mod)
                                                { setpowmod (a, b, mod); }
  cBigPowMod (long a, const cBigNumber& b, cBigNumber& mod)
                                                { setpowmod (a, b, mod); }
  cBigPowMod (long a, const cBigNumber& b, long mod)
                                                { setpowmod (a, b, mod); }
  cBigPowMod (long a, long b, cBigNumber& mod)
                                                { setpowmod (a, b, mod); }
  cBigPowMod (long a, long b, long mod)
                                                { setpowmod (a, b, mod); }
};

struct cBigSqrt: public cBigTemp                        //  .
{
  cBigSqrt (const cBigNumber& a)                        { setsqrt (a);   }
  cBigSqrt (long a)                                     { setsqrt (a);   }
};

struct cBigSqrtRm: public cBigTemp                      // .   .
{
  cBigSqrtRm (cBigNumber& a)                            { setsqrtrm (a); }
};

struct cBigRandom: public cBigTemp                      //  .
{
  cBigRandom (unsigned long (*p)(), unsigned long n)    { setrandom (p, n); }
};

//================================================
//         ,
//         .
//================================================

inline cBigInc   operator ++ (cBigNumber &a, int)
{
  return cBigInc (a);
}

inline cBigDec   operator -- (cBigNumber &a, int)
{
  return cBigDec (a);
}

inline cBigPos   operator + (const cBigNumber &a)
{
  return cBigPos (a);
}

inline cBigNeg   operator - (const cBigNumber &a)
{
  return cBigNeg (a);
}

inline cBigCompl operator ~ (const cBigNumber &a)
{
  return cBigCompl (a);
}

//================================================
//         ,
//         .
//================================================

inline cBigXor operator ^ (const cBigNumber& a, const cBigNumber& b)
{
  return cBigXor (a, b);
}

inline cBigXor operator ^ (const cBigNumber& a, long b)
{
  return cBigXor (a, b);
}

inline cBigXor operator ^ (long b, const cBigNumber& a)
{
  return cBigXor (a, b);
}

inline cBigAnd operator & (const cBigNumber& a, const cBigNumber& b)
{
  return cBigAnd (a, b);
}

inline cBigAnd operator & (const cBigNumber& a, long b)
{
  return cBigAnd (a, b);
}

inline cBigAnd operator & (long b, const cBigNumber& a)
{
  return cBigAnd (a, b);
}

inline cBigOr  operator | (const cBigNumber& a, const cBigNumber& b)
{
  return cBigOr  (a, b);
}

inline cBigOr  operator | (const cBigNumber& a, long b)
{
  return cBigOr  (a, b);
}

inline cBigOr  operator | (long b, const cBigNumber& a)
{
  return cBigOr  (a, b);
}

inline cBigAdd operator + (const cBigNumber& a, const cBigNumber& b)
{
  return cBigAdd (a, b);
}

inline cBigAdd operator + (const cBigNumber& a, long b)
{
  return cBigAdd (a, b);
}

inline cBigAdd operator + (long b, const cBigNumber& a)
{
  return cBigAdd (a, b);
}

inline cBigSub operator - (const cBigNumber& a, const cBigNumber& b)
{
  return cBigSub (a, b);
}

inline cBigSub operator - (const cBigNumber& a, long b)
{
  return cBigSub (a, b);
}

inline cBigSub operator - (long a, const cBigNumber& b)
{
  return cBigSub (a, b);
}

inline cBigMul operator * (const cBigNumber& a, const cBigNumber& b)
{
  return cBigMul (a, b);
}

inline cBigMul operator * (const cBigNumber& a, long b)
{
  return cBigMul (a, b);
}

inline cBigMul operator * (long b, const cBigNumber& a)
{
  return cBigMul (a, b);
}

inline cBigDiv operator / (const cBigNumber& a, const cBigNumber& b)
{
  return cBigDiv (a, b);
}

inline cBigDiv operator / (const cBigNumber& a, long b)
{
  return cBigDiv (a, b);
}

inline cBigDiv operator / (long a, const cBigNumber& b)
{
  return cBigDiv (a, b);
}

inline cBigMod operator % (const cBigNumber& a, const cBigNumber& b)
{
  return cBigMod (a, b);
}

inline cBigMod operator % (const cBigNumber& a, long b)
{
  return cBigMod (a, b);
}

inline cBigMod operator % (long a, const cBigNumber& b)
{
  return cBigMod (a, b);
}

inline cBigShl operator << (const cBigNumber& a, const cBigNumber& b)
{
  return cBigShl (a, b);
}

inline cBigShl operator << (const cBigNumber& a, long b)
{
  return cBigShl (a, b);
}

inline cBigShl operator << (long a, const cBigNumber& b)
{
  return cBigShl (a, b);
}

inline cBigShr operator >> (const cBigNumber& a, const cBigNumber& b)
{
  return cBigShr (a, b);
}

inline cBigShr operator >> (const cBigNumber& a, long b)
{
  return cBigShr (a, b);
}

inline cBigShr operator >> (long a, const cBigNumber& b)
{
  return cBigShr (a, b);
}

#endif//_CBIGNUM_H
